'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRockeyHoc = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _isString = require('lodash/isString');

var _isString2 = _interopRequireDefault(_isString);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _rule = require('rockey/rule');

var _rule2 = _interopRequireDefault(_rule);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var WAS_CALLED_AS_CSS = 'WAS_CALLED_AS_CSS';
var WAS_CALLED_AS_CSS_EXTENDS = 'WAS_CALLED_AS_CSS_EXTENDS';
var WAS_CALLED_AS_REACT_COMPONENT = 'WAS_CALLED_AS_REACT_COMPONENT';

var getCallType = function getCallType() {
  if (arguments.length === 1 && (0, _isString2.default)(arguments.length <= 0 ? undefined : arguments[0])) {
    return WAS_CALLED_AS_CSS_EXTENDS;
  } else if (Array.isArray(arguments.length <= 0 ? undefined : arguments[0])) {
    return WAS_CALLED_AS_CSS;
  } else {
    return WAS_CALLED_AS_REACT_COMPONENT;
  }
};

var renderReactComopnent = function renderReactComopnent(BaseComponent, _ref) {
  var props = _ref.props,
      css = _ref.css,
      displayName = _ref.displayName;

  var classList = css ? css.getClassList(props) : {};

  return _react2.default.createElement(BaseComponent, Object.assign({}, props, {
    className: (0, _classnames2.default)(classList[displayName], props.className)
  }));
};

var anonymysRockeyCounter = 0;
var childCounter = {};

var getRockeyHoc = exports.getRockeyHoc = function getRockeyHoc() {
  var CreateRockeyHoc = function CreateRockeyHoc(BaseComponent) {
    var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        displayName = _ref2.displayName,
        _ref2$parentCss = _ref2.parentCss,
        parentCss = _ref2$parentCss === undefined ? null : _ref2$parentCss;

    if ((0, _isString2.default)(BaseComponent)) {
      displayName = displayName || BaseComponent;
    } else if (!parentCss) {
      displayName = displayName || BaseComponent.displayName || 'AnonymysRockey' + ++anonymysRockeyCounter;
    } else {
      displayName = displayName || 'AnonymysRockey' + ++anonymysRockeyCounter;
    }

    return function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var CALL_TYPE = getCallType.apply(undefined, args);

      if (CALL_TYPE === WAS_CALLED_AS_REACT_COMPONENT) {
        return renderReactComopnent(BaseComponent, {
          props: args[0],
          displayName: displayName,
          css: parentCss
        });
      }

      var css = _rule2.default.apply(undefined, args);

      if (parentCss) {
        css.addParent(parentCss);
      }

      css.wrapWith(displayName);

      var RockeyHoc = function RockeyHoc() {
        for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        var CALL_TYPE = getCallType.apply(undefined, args);

        switch (CALL_TYPE) {
          case WAS_CALLED_AS_CSS_EXTENDS:
            return function (childStrings) {
              for (var _len3 = arguments.length, childValues = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
                childValues[_key3 - 1] = arguments[_key3];
              }

              var childCss = _rule2.default.apply(undefined, [childStrings].concat(childValues));

              return CreateRockeyHoc(BaseComponent, {
                displayName: args[0],
                parentCss: css
              }).apply(undefined, [childStrings].concat(childValues));
            };

          case WAS_CALLED_AS_CSS:
            if (!childCounter[displayName]) {
              childCounter[displayName] = 0;
            }

            return CreateRockeyHoc(BaseComponent, {
              displayName: 'Child' + displayName + '-' + ++childCounter[displayName],
              parentCss: css
            }).apply(undefined, [args[0]].concat(_toConsumableArray(args.slice(1))));

          case WAS_CALLED_AS_REACT_COMPONENT:
            return renderReactComopnent(BaseComponent, {
              props: args[0],
              displayName: displayName,
              css: css
            });

          default:
            throw new Error('Wrong component call');
        }
      };

      RockeyHoc.displayName = 'Rockey(' + displayName + ')';

      return RockeyHoc;
    };
  };

  return CreateRockeyHoc;
};

var RockeyHoc = getRockeyHoc();
exports.default = RockeyHoc;