'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isString = require('lodash/isString');

var _isString2 = _interopRequireDefault(_isString);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _htmlTags = require('./htmlTags');

var _htmlTags2 = _interopRequireDefault(_htmlTags);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ucfirst = function ucfirst(s) {
  return s.charAt(0).toUpperCase() + s.slice(1);
};
var counter = {};

var assignShortcuts = function assignShortcuts(RockeyHoc) {
  var _loop = function _loop(tag) {
    // ---- tag hoc lazy creation
    Object.defineProperty(RockeyHoc, tag, {
      get: function get() {
        return function () {
          if (arguments.length === 1 && (0, _isString2.default)(arguments.length <= 0 ? undefined : arguments[0])) {
            // ---- use with defined displayName
            return RockeyHoc(tag, {
              displayName: ucfirst(arguments.length <= 0 ? undefined : arguments[0])
            });
          } else if ((0, _isArray2.default)(arguments.length <= 0 ? undefined : arguments[0])) {
            // ---- use as anonymys tag shortcut
            if (!counter[tag]) {
              counter[tag] = 0;
            }

            return RockeyHoc(tag, {
              displayName: 'Shortcut' + ucfirst(tag) + ++counter[tag]
            }).apply(undefined, arguments);
          } else {
            throw new Error('shortcut.' + tag + ' used as React Component but without defined styles. Use jsx syntax directly for such cases - "<' + tag + '>...</' + tag + '>"');
          }
        };
      },
      set: function set() {
        throw new Error('Override default RockeyHoc shorcuts is disabled');
      }
    });
  };

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = _htmlTags2.default[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var tag = _step.value;

      _loop(tag);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
};

exports.default = assignShortcuts;